nitg: Modified compilation routine to avoid use of String contructors
[nit.git] / tests / tests.sh
index 6c181f4..3ea9dca 100755 (executable)
@@ -19,6 +19,7 @@
 
 # Set lang do default to avoid failed tests because of locale
 export LANG=C
+export NIT_TESTING=true
 
 usage()
 {
@@ -35,6 +36,35 @@ Usage: $e [options] modulenames
 END
 }
 
+# $1 is the pattern of the test
+# $2 is the file to compare to
+# the result is:
+#   0: if the file to compare to do not exists
+#   1: if the file match
+#   2: if the file match with soso
+#   3: if the file do not match
+function compare_to_result()
+{
+       local pattern="$1"
+       local sav="$2"
+       if [ ! -r "$sav" ]; then return 0; fi
+       diff -u "$sav" "out/$pattern.res" > "out/$pattern.diff.sav.log"
+       if [ "$?" == 0 ]; then
+               return 1
+       fi
+       [ -z "$soso" ] && return 3
+       sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
+       sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
+       grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
+       grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
+       diff -u "out/$pattern.sav2" "out/$pattern.res2" > "out/$pattern.diff.sav.log"
+       if [ "$?" == 0 ]; then
+               return 2
+       else
+               return 3
+       fi
+}
+
 # As argument: the pattern used for the file
 function process_result()
 {
@@ -42,6 +72,7 @@ function process_result()
        # Result
        pattern=$1
        description=$2
+       pack=$3
        SAV=""
        NSAV=""
        FIXME=""
@@ -50,47 +81,32 @@ function process_result()
        NSOSO=""
        SOSOF=""
        NSOSOF=""
+       echo >>$xml "<testcase classname='$pack' name='$description'>"
        for sav in "sav/$engine/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
-               if [ -r "$sav" ]; then
-                       diff -u "out/$pattern.res" "$sav" > "out/$pattern.diff.sav.log"
-                       if [ "$?" == 0 ]; then
-                               SAV="$sav"
-                       else
-                               NSAV="$sav"
-                       fi
-                       [ -z "$soso" ] && continue
-                       sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
-                       sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
-                       grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
-                       grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
-                       diff -u "out/$pattern.res2" "out/$pattern.sav2" > "out/$pattern.diff.sav2.log"
-                       if [ "$?" == 0 ]; then
-                               SOSO="$sav"
-                       else
-                               NSOSO="$sav"
-                       fi
-               fi
+               compare_to_result "$pattern" "$sav"
+               case "$?" in
+                       0)
+                               ;; # no file
+                       1)
+                               SAV="$sav" ;;
+                       2)
+                               SOSO="$sav" ;;
+                       3)
+                               NSAV="$sav";;
+               esac
        done
        for sav in "sav/$engine/fixme/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.fail"; do
-               if [ -r "$sav" ]; then
-                       diff -u "out/$pattern.res" "$sav" > "out/$pattern.diff.fail.log"
-                       if [ "$?" == 0 ]; then
-                               FIXME="$sav"
-                       else
-                               NFIXME="$sav"
-                       fi
-                       [ -z "$soso" ] && continue
-                       sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
-                       sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.fail2"
-                       grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
-                       grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.fail2"
-                       diff -u "out/$pattern.res2" "out/$pattern.fail2" > "out/$pattern.diff.fail2.log"
-                       if [ "$?" == 0 ]; then
-                               SOSOF="$sav"
-                       else
-                               NSOSOF="$sav"
-                       fi
-               fi
+               compare_to_result "$pattern" "$sav"
+               case "$?" in
+                       0)
+                               ;; # no file
+                       1)
+                               FIXME="$sav" ;;
+                       2)
+                               SOSOF="$sav" ;;
+                       3)
+                               NFIXME="$sav";;
+               esac
        done
        grep 'NOT YET IMPLEMENTED' "out/$pattern.res" >/dev/null
        NYI="$?"
@@ -109,7 +125,7 @@ function process_result()
                else
                        echo "[fixme] out/$pattern.res $FIXME"
                fi
-               ok="$ok $pattern"
+               todos="$todos $pattern"
        elif [ -n "$SOSO" ]; then
                if [ -n "$tap" ]; then
                        echo "ok - $description # SOSO"
@@ -130,13 +146,17 @@ function process_result()
                else
                        echo "[fixme soso] out/$pattern.res $SOSOF"
                fi
-               ok="$ok $pattern"
+               todos="$todos $pattern"
        elif [ -n "$NSAV" ]; then
                if [ -n "$tap" ]; then
                        echo "not ok - $description"
                else
                        echo "[======= fail out/$pattern.res $NSAV =======]"
                fi
+               echo >>$xml "<error message='fail out/$pattern.res $NSAV'/>"
+               echo >>$xml "<system-out><![CDATA["
+               head >>$xml -n 50 out/$pattern.diff.sav.log
+               echo >>$xml "]]></system-out>"
                nok="$nok $pattern"
                echo "$ii" >> "$ERRLIST"
        elif [ -n "$NFIXME" ]; then
@@ -145,6 +165,10 @@ function process_result()
                else
                        echo "[======= changed out/$pattern.res $NFIXME ======]"
                fi
+               echo >>$xml "<error message='changed out/$pattern.res $NFIXME'/>"
+               echo >>$xml "<system-out><![CDATA["
+               head >>$xml -n 50 out/$pattern.diff.sav.log
+               echo >>$xml "]]></system-out>"
                nok="$nok $pattern"
                echo "$ii" >> "$ERRLIST"
        else
@@ -153,20 +177,31 @@ function process_result()
                else
                        echo "[=== no sav ===] out/$pattern.res"
                fi
+               echo >>$xml "<skipped/>"
+               echo >>$xml "<system-out><![CDATA["
+               cat  >>$xml out/$pattern.res
+               echo >>$xml "]]></system-out>"
                nos="$nos $pattern"
        fi
+       if test -s out/$pattern.cmp.err; then
+               echo >>$xml "<system-err><![CDATA["
+               cat  >>$xml out/$pattern.cmp.err
+               echo >>$xml "]]></system-err>"
+       fi
+       echo >>$xml "</testcase>"
 }
 
 need_skip()
 {
        test "$noskip" = true && return 1
-       if grep "$engine" "sav/$1.skip" >/dev/null 2>&1 || echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
+       if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
                ((tapcount=tapcount+1))
                if [ -n "$tap" ]; then
                        echo "ok - $2 # skip"
                else
                        echo "=> $2: [skip]"
                fi
+               echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
                return 0
        fi
        return 1
@@ -215,7 +250,9 @@ done
 enginebinname=$engine
 case $engine in
        nitc) ;;
-       nitg) ;;
+       nitg) OPT="--global $OPT";;
+       nitg-s) enginebinname=nitg; OPT="--separate $OPT";;
+       nitg-e) enginebinname=nitg; OPT="--erasure $OPT";;
        nit) engine=niti ;;
        niti) enginebinname=nit ;;
 esac
@@ -226,6 +263,13 @@ esac
 # Set NIT_DIR if needed
 [ -z "$NIT_DIR" ] && export NIT_DIR=..
 
+if sh -c "timelimit echo" 1>/dev/null 2>&1; then
+       TIMEOUT="timelimit -t 600"
+elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
+       TIMEOUT="timeout 600s"
+else
+       echo "No timelimit or timeout command detected. Tests may hang :("
+fi
 
 # Mark to distinguish files among tests
 # MARK=
@@ -251,6 +295,8 @@ fi
 ok=""
 nok=""
 todos=""
+xml="tests-$engine.xml"
+echo >$xml "<testsuites><testsuite>"
 
 # CLEAN the out directory
 rm -rf out/ 2>/dev/null
@@ -263,8 +309,10 @@ for ii in "$@"; do
        fi
        f=`basename "$ii" .nit`
 
+       pack=`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
+
        # Sould we skip the file for this engine?
-       need_skip $f $f && continue
+       need_skip $f $f $pack && continue
 
        tmp=${ii/../AA}
        if [ "x$tmp" = "x$ii" ]; then
@@ -278,7 +326,7 @@ for ii in "$@"; do
                ff="out/$bf"
 
                # Sould we skip the alternative for this engine?
-               need_skip $bf $bf && continue
+               need_skip $bf $bf $pack && continue
 
                test -z "$tap" && echo -n "=> $bf: "
 
@@ -302,7 +350,7 @@ END
                                echo ""
                                echo $NITC --no-color $OPT -o "$ff.bin" "$i" "$includes"
                        fi
-                       NIT_NO_STACK=1 $NITC --no-color $OPT -o "$ff.bin" "$i" $includes 2> "$ff.cmp.err" > "$ff.compile.log"
+                       NIT_NO_STACK=1 $TIMEOUT $NITC --no-color $OPT -o "$ff.bin" "$i" $includes 2> "$ff.cmp.err" > "$ff.compile.log"
                        ERR=$?
                        if [ "x$verbose" = "xtrue" ]; then
                                cat "$ff.compile.log"
@@ -312,9 +360,8 @@ END
                if [ "$ERR" != 0 ]; then
                        test -z "$tap" && echo -n "! "
                        cat "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
-                       process_result $bf $bf
+                       process_result $bf $bf $pack
                elif [ -x "./$ff.bin" ]; then
-                       cp "$ff.cmp.err" "$ff.res"
                        test -z "$tap" && echo -n ". "
                        # Execute
                        args=""
@@ -322,7 +369,7 @@ END
                                echo ""
                                echo "NIT_NO_STACK=1 ./$ff.bin" $args
                        fi
-                       NIT_NO_STACK=1 "./$ff.bin" $args < "$inputs" >> "$ff.res" 2>"$ff.err"
+                       NIT_NO_STACK=1 $TIMEOUT "./$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
                        if [ "x$verbose" = "xtrue" ]; then
                                cat "$ff.res"
                                cat >&2 "$ff.err"
@@ -332,10 +379,9 @@ END
                        elif [ -d "$ff.write" ]; then
                                LANG=C /bin/ls -F $ff.write >> "$ff.res"
                        fi
-                       if [ -s "$ff.err" ]; then
-                               cat "$ff.err" >> "$ff.res"
-                       fi
-                       process_result $bf $bf
+                       cp "$ff.res"  "$ff.res2"
+                       cat "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
+                       process_result $bf $bf $pack
 
                        if [ -f "$f.args" ]; then
                                fargs=$f.args
@@ -345,17 +391,20 @@ END
                                        args="$line"
                                        bff=$bf"_args"$cptr
                                        fff=$ff"_args"$cptr
+                                       name="$bf args $cptr"
 
                                        # Sould we skip the input for this engine?
-                                       need_skip $bff "  args #$cptr" && continue
+                                       need_skip $bff "  $name" $pack && continue
 
                                        rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
                                        if [ "x$verbose" = "xtrue" ]; then
                                                echo ""
                                                echo "NIT_NO_STACK=1 ./$ff.bin" $args
                                        fi
-                                       test -z "$tap" && echo -n "==> args #"$cptr " "
-                                       sh -c "NIT_NO_STACK=1 ./$ff.bin  ''$args < $inputs > $fff.res 2>$fff.err"
+                                       test -z "$tap" && echo -n "==> $name "
+                                       echo "./$ff.bin $args" > "./$fff.bin"
+                                       chmod +x "./$fff.bin"
+                                       sh -c "NIT_NO_STACK=1 $TIMEOUT ./$fff.bin < $inputs > $fff.res 2>$fff.err"
                                        if [ "x$verbose" = "xtrue" ]; then
                                                cat "$fff.res"
                                                cat >&2 "$fff.err"
@@ -366,16 +415,17 @@ END
                                                LANG=C /bin/ls -F $fff.write >> "$fff.res"
                                        fi
                                        if [ -s "$fff.err" ]; then
-                                               cat "$fff.err" >> "$fff.res"
+                                               cp "$fff.res"  "$fff.res2"
+                                               cat "$fff.err" "$fff.res2" > "$fff.res"
                                        fi
-                                       process_result $bff "  args #$cptr"
+                                       process_result $bff "  $name" $pack
                                done < $fargs
                        fi
                else
                        test -z "$tap" && echo -n "! "
                        cat "$ff.cmp.err" > "$ff.res"
                        echo "Compilation error" > "$ff.res"
-                       process_result $bf "$bf"
+                       process_result $bf "$bf" $pack
                fi
        done
 done
@@ -385,7 +435,7 @@ if [ -n "$tap" ]; then
        echo "# ok:" `echo $ok | wc -w`
        echo "# not ok:" `echo $nok | wc -w`
        echo "# no sav:" `echo $nos | wc -w`
-       echo "# todos:" `echo $todos | wc -w`
+       echo "# todo/fixme:" `echo $todos | wc -w`
        exit
 fi
 
@@ -399,7 +449,7 @@ if [ -n "$nos" ]; then
        echo "no sav: $nos"
 fi
 if [ -n "$todos" ]; then
-       echo "todos: $todos"
+       echo "todo/fixme: $todos"
 fi
 
 # write $ERRLIST
@@ -410,6 +460,8 @@ if [ "x$ERRLIST" != "x" ]; then
        mv $ERRLIST $ERRLIST_TARGET
 fi
 
+echo >>$xml "</testsuite></testsuites>"
+
 if [ -n "$nok" ]; then
        exit 1
 else